#define map(x,y)    (sol_nv1_map[y][x])
#define Map(x,y)    (sol_nv1_map[y][x])

typedef struct	{
	struct	{
		int ESC			:1;
		int start		:1;
		int select      :1;
		int SECOND    	:1;
	}	ft;
} TOUCHES_INTERDITES;

enum evenements {EV_AUCUN=0,EV_QUITTER,EV_PAUSE};

int nSprite=1;

TOUCHES_INTERDITES interdit;
#define mat(x,y)    (sol_nv1_map[y][x])

#define ecrX	(Ecran->scrlX)
#define ecrY	(Ecran->scrlY)

typedef struct	{				//Structure d'un sprite
	short type;						//Type (identifieur) du sprite
	short x;							//Position x (absolue)
	short y;							//Position y (absolue)
	short dir;						//Direction du sprite
	short cpt;						//Compteur
	short etat;						//Etat spcial
	short depX;						//Position x de dpart
	short depY;						//Position y de dpart
	short vitesse;				//Vitesse du sprite
	short gravite;				//Sa gravit
	short saut;						//Saut effectu
	short hauteur;				//Sa hauteur
	short largeur;				//Sa largeur
	short saut_obligatoire;
	struct	{							//Flags de collisions autour du sprite
		short gauche:1,droite:1,haut:1,bas:1;
	} collisions;
	short no_sprite;
} SPRITE;

typedef unsigned char * TABLEAU;
typedef SPRITE * PSPRITE;

typedef struct	{				//Infos sur l'cran
	TABLEAU Tampon;				//"Backbuffer" de l'cran
	short scrlX;					//Scrolling x (toujours modulo 8)
	short scrlY;					//Scrolling y (toujours modulo 8)
} ECRAN;

enum typeSprites {SPR_MARIO=1,SPR_GOOMBA,SPR_GOOMBA_APLATI, SPR_FAIT_RIEN};

void InitSprite(SPRITE *s, short type, short x, short y, short l, short h, short vitesse)	{
	s->type=type;
	s->x=x;
	s->y=y;
	if (vitesse<0)
		s->dir=-1;
	else
		s->dir=1;
	s->cpt=0;
	s->etat=0;
	s->depX=x;
	s->depY=y;
	s->vitesse=vitesse;
	s->saut=0;
	s->gravite=2;
	s->hauteur=h;
	s->largeur=l;
	s->saut_obligatoire=0;
}

short GereTouches(SPRITE *s)	{
	short i=1;

/*	if (_keytest(RR_ESC))	{
		if (!interdit.ft.ESC)	{
			interdit.ft.ESC=1;
			return EV_QUITTER;
		}
	}
	else
		interdit.ft.ESC=0;

	if (_keytest(RR_APPS))	{
		if (!interdit.ft.APPS)	{
			interdit.ft.APPS=1;
			return EV_PAUSE;
		}
	}
	else
		interdit.ft.APPS=0;*/

	if (REG_TOUCHES&TOUCHE_B)
		i=2;

	if (REG_TOUCHES&TOUCHE_DROITE)		{		//Augmente sa vitesse (vitesse positive= droite)
		s->vitesse=i;
		s->dir=1;
	}
	else if (REG_TOUCHES&TOUCHE_GAUCHE)	{	//Diminue sa vitesse (vitesse ngative= gauche)
		s->vitesse=-i;
		s->dir=-1;
	}
	else													//Freine Mario suivant sa direction (aucune touche appuye)
		s->vitesse=0;

	if (s->saut_obligatoire>0)	{
		s->saut=0;
		s->gravite=-((s->saut_obligatoire--)/5);
	}
	else
		s->gravite=2;

	if (REG_TOUCHES&TOUCHE_A && !interdit.ft.SECOND)	{
		s->gravite=-((40-s->saut)/9);
		s->saut++;
		if (s->saut>=30)	{
			s->gravite=2;
			interdit.ft.SECOND=1;			//Sommet du saut -> on redescend
		}
	}
	else	{
		if (s->saut>0)	{
			s->saut--;
			s->gravite=2;
			interdit.ft.SECOND=1;
		}
	}

	if (s->saut==0 && s->saut_obligatoire==0)		s->gravite=4;
	return EV_AUCUN;
}

void BougeSprite(SPRITE *s,short index)	{
	if (s->vitesse>0 && index<s->vitesse)
		s->x++;
	else if (s->vitesse<0 && index<-(s->vitesse))
		s->x--;

	if (s->gravite>0 && !(s->collisions.bas) && index<s->gravite)
		s->y++;
	else if (s->gravite<0 && !(s->collisions.haut) && index<-(s->gravite))
		s->y--;
// 	if (s->collisions.bas && index<s->gravite && s->gravite>=0)
// 		s->y--;
	if (s->collisions.droite)					s->x--;
	else if (s->collisions.gauche)		s->x++;
	if (s->collisions.haut)
	   s->saut=30;

	if (s->type==SPR_GOOMBA)	{
		if (s->collisions.gauche)
			s->vitesse=1;
		else if (s->collisions.droite)
			s->vitesse=-1;
	}

	if (s->type!=SPR_MARIO)		return;																		//Ne pas grer a pour les ennemis

	if (s->collisions.bas)		{																					//Saut termin (Mario repose  prsent sur une plate-forme)
		if (!(REG_TOUCHES&TOUCHE_A))	{
			interdit.ft.SECOND=0;
			s->saut=0;
		}
	}
	else if (!(s->saut))											interdit.ft.SECOND=1;			//Pas qu'il saute en plein vide
}

#define TILE 16

void DetecteCollisions(TABLEAU table,ECRAN *Ecran,SPRITE *s)	{
	short H=s->hauteur, L=s->largeur;

	s->collisions.gauche=s->collisions.haut=s->collisions.droite=s->collisions.bas=0;

    if (s->y+H>=TABLE_Y*TILE)
        s->collisions.droite=1;
	if (mat((s->x+1)/TILE,(s->y+H)/TILE)>=1 && mat((s->x+1)/TILE,(s->y+H)/TILE)<=32)
		s->collisions.bas=1;
	if (mat((s->x+L-1)/TILE,(s->y+H)/TILE)>=1 && mat((s->x+L-1)/TILE,(s->y+H)/TILE)<=32)
		s->collisions.bas=1;

	if (s->y<=0)	s->collisions.haut=1;
   	if (mat((s->x+1)/TILE,(s->y)/TILE)>=1 && mat((s->x+1)/TILE,(s->y)/TILE)<=32)
		s->collisions.haut=1;
	if (mat((s->x+L-1)/TILE,(s->y)/TILE)>=1 && mat((s->x+L-1)/TILE,(s->y)/TILE)<=32)
		s->collisions.haut=1;
	
	if (s->x<=0)	s->collisions.gauche=1;
	if (mat((s->x)/TILE,(s->y+1)/TILE)>=1 && mat((s->x)/TILE,(s->y+1)/TILE)<=32)
		s->collisions.gauche=1;
	if (mat((s->x)/TILE,(s->y+H-1)/TILE)>=1 && mat((s->x)/TILE,(s->y+H-1)/TILE)<=32)
		s->collisions.gauche=1;

    if (s->x+L>=TABLE_X*TILE)
        s->collisions.droite=1;
	if (mat((s->x+L)/TILE,(s->y+1)/TILE)>=1 && mat((s->x+L)/TILE,(s->y+1)/TILE)<=32)
		s->collisions.droite=1;
	if (mat((s->x+L)/TILE,(s->y+H-1)/TILE)>=1 && mat((s->x+L)/TILE,(s->y+H-1)/TILE)<=32)
		s->collisions.droite=1;
}

#define SPRITE_LIMIT 100
enum collisions {COL_AUCUNE,COL_NORMALE,COL_DESSUS};
//Dtecte une collision entre s1 et s2 et renvoie le rsultat
short CollisionEntreDeuxSprites(SPRITE *s1,SPRITE *s2)	{
	if (s1->x+s1->largeur>s2->x && s1->x<s2->x+s2->largeur &&
		s1->y+s1->hauteur>s2->y && s1->y<s2->y+s2->hauteur)	{
			if (s1->y+s1->hauteur<=s2->y+5)
				return COL_DESSUS;
			else
				return COL_NORMALE;
	}
	return COL_AUCUNE;
}

short CreeSprite(SPRITE *sprites, short type, short x, short y, short dir)	{
	short i,j;
	for (i=0;i<SPRITE_LIMIT && sprites[i].type!=0;i++);

	if (i>=SPRITE_LIMIT)
		return 0;

	InitSprite(&sprites[i],type,x,y,16,16,dir);
	sprites[i].no_sprite=i+1;
	if (nSprite>120)
	   nSprite=120;
    if (type==SPR_GOOMBA)
        j=1<<3;
    else if (type==SPR_GOOMBA_APLATI)
        j=2<<3;
    else
        j=0<<3;
    CreeObjet(sprites[i].no_sprite,            //Numro d'objet
    j,                      //Numro de mosaque (3), <<2 car 16x16 (*4) et <<1 car mode 8 bits (*2)
    x,                      //Position X initiale
    y,                      //Position Y initiale
    0,                      //Mode (alpha-blend)
    0,                      //Forme (0=carre)
    1,                      //Taille
    1,                      //Mode palette (1=256 couleurs, 0=16 couleurs)
    0,                      //Numro de palette si 16 couleurs
    1,                      //Priorit
    0,                      //Retournement vertical
    0,                      //Retournement horizontal
    0,                      //Mode mosaque (?)
    0,                      //Rotation
    0,                      //N de rotation
    0);                     //Double-taille (pour rotation)
	return 1;
}
void DetruitSprite(SPRITE *s)   {
    s->type=0;
    DetruitObjet(s->no_sprite);
}

void GereSprites(TABLEAU table,SPRITE *sprites,SPRITE *mario,ECRAN *Ecran)	{
	short i,c;
	int x,y;
	for (i=0;i<SPRITE_LIMIT;i++)	{
		switch (sprites[i].type)	{
			case SPR_GOOMBA:
				DetecteCollisions(table,Ecran,&sprites[i]);
				sprites[i].cpt++;
				sprites[i].cpt=sprites[i].cpt%16;
				BougeSprite(&sprites[i],sprites[i].cpt%2);
				c=CollisionEntreDeuxSprites(mario,&sprites[i]);
				if (c==COL_DESSUS)			{
					DetruitSprite(&sprites[i]);
					mario->saut_obligatoire=15;
					CreeSprite(sprites,SPR_GOOMBA_APLATI,sprites[i].x,sprites[i].y,0);
    				break;
				}
				else if (c==COL_NORMALE)	DetruitSprite(mario);
				PositionRelativeObjet16x16(sprites[i].x,sprites[i].y,ecrX,ecrY,&x,&y);
                if (sprites[i].cpt%16>=8)        {
                    RetourneObjetH_Non(sprites[i].no_sprite);
                }
                else        {
                    RetourneObjetH_Oui(sprites[i].no_sprite);
                }
				PlaceObjetXY(sprites[i].no_sprite,x,y);
				break;
			case SPR_GOOMBA_APLATI:
				DetecteCollisions(table,Ecran,&sprites[i]);
				if ((sprites[i].cpt++)>100)
					DetruitSprite(&sprites[i]);
				BougeSprite(&sprites[i],0);
				if (sprites[i].cpt<70 || sprites[i].cpt%2)      {
				    ChangeTileObjet(sprites[i].no_sprite,2<<3);
				}
				else    {
				    ChangeTileObjet(sprites[i].no_sprite,3<<3);
                }
				PositionRelativeObjet16x16(sprites[i].x,sprites[i].y,ecrX,ecrY,&x,&y);
				PlaceObjetXY(sprites[i].no_sprite,x,y);
				break;
			case SPR_FAIT_RIEN:
				PositionRelativeObjet16x16(sprites[i].x,sprites[i].y,ecrX,ecrY,&x,&y);
				PlaceObjetXY(sprites[i].no_sprite,x,y);
				break;
		}
	}
}


